/*
 * aloba ag , Copyright (c) 2006
 * created 21.04.2006 by Hansjoerg
 */
package ch.aloba.mpeeditor.configuration;

import ch.aloba.model.DataModel;
import ch.aloba.mpeeditor.ExampleEditorPlugin;
import ch.aloba.mpeeditor.editor.ExampleEditorUndoManager;
import ch.aloba.mpefw.configuration.IMpeFwConfiguration;
import ch.aloba.mpefw.editor.AbstractMpeFwEditor;
import ch.aloba.mpefw.editor.AbstractMpeFwUndoManager;
import ch.aloba.mpefw.model.base.AbstractModelMpeFw;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.pde.internal.ui.editor.ISortableContentOutlinePage;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.plugin.AbstractUIPlugin;

/**
 * TODO add class description ...
 *
 * @author Hansjoerg
 * @version $Revision: 1.1 $
 */
public class ExampleConfiguration implements IMpeFwConfiguration
{
    private AbstractModelMpeFw m_model = null;

    /**
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#logException(java.lang.Exception)
     */
    public void logException(Exception e)
    {
        ExampleEditorPlugin.getDefault().logException(e);
    }

    /**
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#getPluginId()
     */
    public String getPluginId()
    {
        return ExampleEditorPlugin.getDefault().getPluginId();
    }

    /**
     *
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#getPlugin()
     */
    public AbstractUIPlugin getPlugin()
    {
        return ExampleEditorPlugin.getDefault();
    }

    /**
     *
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#getActiveWorkbenchShell()
     */
    public Shell getActiveWorkbenchShell()
    {
        return ExampleEditorPlugin.getActiveWorkbenchShell();
    }

    /**
     *
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#getActionImageDescriptors(java.lang.String)
     */
    public ImageDescriptor[] getActionImageDescriptors(String imageName)
    {
        return ExampleEditorPlugin.getActionImageDescriptors(imageName);
    }

    /**
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#getResourceString(java.lang.String)
     */
    public String getResourceString(String key)
    {
        return "";
    }

    /**
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#getContextId()
     */
    public String getContextId()
    {
        return "example-context";
    }

    /**
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#instantiateModel(org.eclipse.core.resources.IFile)
     */
    public AbstractModelMpeFw instantiateModel(IFile file)
    {
        m_model = new DataModel(file);
        return m_model;
    }

    /**
     *
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#getModel()
     */
    public AbstractModelMpeFw getModel()
    {
        return m_model;
    }

    /**
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#getUndoManager(ch.aloba.mpefw.editor.AbstractMpeFwEditor)
     */
    public AbstractMpeFwUndoManager getUndoManager(AbstractMpeFwEditor editor)
    {
        return new ExampleEditorUndoManager(editor);
    }

    /**
     * @see ch.aloba.mpefw.configuration.IMpeFwConfiguration#getContentOutline(ch.aloba.mpefw.editor.AbstractMpeFwEditor)
     */
    public ISortableContentOutlinePage getContentOutline(AbstractMpeFwEditor editor)
    {
        return null;
    }
}


