/*
 * aloba ag , Copyright (c) 2006
 * created 30.06.2006 by Hansjoerg
 */
package ch.aloba.mpeeditor.editor.pages;

import ch.aloba.model.DataModel;
import ch.aloba.model.imodel.IData;
import ch.aloba.model.imodel.IPerson;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.pde.core.IBaseModel;
import org.eclipse.pde.core.IModelChangeProvider;
import org.eclipse.pde.core.IModelChangedEvent;
import org.eclipse.pde.internal.ui.editor.PDEFormPage;
import org.eclipse.pde.internal.ui.editor.TableSection;
import org.eclipse.pde.internal.ui.elements.DefaultContentProvider;
import org.eclipse.pde.internal.ui.parts.TablePart;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.Section;

/**
 * TODO add class description ...
 *
 * @author Hansjoerg
 * @version $Revision: 1.1 $
 */
public class MainSection extends TableSection
{
    private TableViewer personTable;

    /**
     * @param formPage
     * @param parent
     * @param style
     * @param buttonLabels
     */
    public MainSection(PDEFormPage formPage, Composite parent)
    {
        super(formPage, parent, Section.TITLE_BAR, new String[] {});
        getSection().setText("Person Details");
        handleDefaultButton = false;
        getTablePart().setEditable(false);
    }


    /**
     * @see org.eclipse.pde.internal.ui.editor.PDESection#createClient(org.eclipse.ui.forms.widgets.Section, org.eclipse.ui.forms.widgets.FormToolkit)
     */
    protected void createClient(Section section, FormToolkit toolkit)
    {
        Composite container = createClientContainer(section, 2, toolkit);
        TablePart tablePart = getTablePart();
        createViewerPartControl(container, SWT.MULTI, 2, toolkit);
        personTable = tablePart.getTableViewer();
        personTable.setContentProvider(new TableContentProvider());
        personTable.setLabelProvider(new TableLabelProvider());
        toolkit.paintBordersFor(container);
        section.setClient(container);
        personTable.setInput(getPage());

        IBaseModel model = getPage().getModel();
        if (model instanceof IModelChangeProvider)
            ((IModelChangeProvider) model).addModelChangedListener(this);
        tablePart.setButtonEnabled(0, model.isEditable());
    }

    public void modelChanged(IModelChangedEvent event)
    {
        // un-optimized -> if there is a change, simple refresh the complete table
        markStale();
    }


    public void refresh() {
        personTable.refresh();
        getManagedForm().fireSelectionChanged(this, personTable.getSelection());
        super.refresh();
    }

    private class TableContentProvider extends DefaultContentProvider
                                       implements IStructuredContentProvider
    {
        public Object[] getElements(Object inputElement)
        {
            DataModel dataModel = (DataModel) getPage().getModel();
            IData data = (IData) dataModel.getRootObject();
            return data.getPersonEntries();
        }
    }

    private class TableLabelProvider extends LabelProvider
    {
        public String getText(Object obj)
        {
            IPerson person = (IPerson) obj;
            return person.getName();
        }
    }
}


