/*
 * aloba ag , Copyright (c) 2006
 * created 31.03.2006 by Hansjoerg
 */
package ch.aloba.mpefw.configuration;

/**
 * Singleton class to define and to get the actual configuration object.
 * Classes of the framework access the configuration via this Class.
 *
 * @author Hansjoerg
 * @version $Revision: 1.1 $
 */
public class ConfigurationFactory
{
    private static IMpeFwConfiguration s_config = null;

    /**
     * @return IMpeFwConfiguration returns the actual configuration.
     */
    public static IMpeFwConfiguration getConfiguration()
    {
        return s_config;
    }

    /**
     * Sets the configuration.
     * @param configuration configuration instance.
     */
    public static void setConfiguration(IMpeFwConfiguration configuration)
    {
        s_config = configuration;
    }
}


