/*
 * aloba ag , Copyright (c) 2006
 * created 31.03.2006 by Hansjoerg
 */
package ch.aloba.mpefw.model.base;

import java.io.PrintWriter;

import org.eclipse.core.runtime.CoreException;
import org.w3c.dom.Node;

public interface IModelObject
{
    /**
     * A property name that will be used to notify about changes in the "label"
     * field.
     */
    public String P_LABEL = "label"; //$NON-NLS-1$

    /**
     * Returns the label of this feature model object'
     *
     * @return feature object label
     */
    public String getLabel();

    /**
     * Returns the site model that owns this model object.
     *
     * @return the site model
     */
    public IModelMpeFw getModel();

    public boolean isInTheModel();

    /**
     * Returns the parent of this model object.
     *
     * @return the model object parent
     */
    public IModelObject getParent();

    /**
     * Sets the new label of this model object. This method may throw a
     * CoreException if the model is not editable.
     *
     * @param label
     *            the new label
     */
    public void setLabel(String label) throws CoreException;

    /**
     * Returns true if this object as all the required attributes set, false
     * otherwise.
     */
    public boolean isValid();

    /**
     * Writes the ASCII representation of the writable into the provider writer.
     * The writable should use the provided indent to write the stream starting
     * from the specified column number. Indent string should be written to the
     * writer after every new line.
     *
     * @param indent
     *            a string that should be added after each new line to maintain
     *            desired horizontal alignment
     * @param writer
     *            a writer to be used to write this object's textual
     *            representation
     */
    public void write(String indent, PrintWriter writer);

    /**
     * parses the node and fills the attributes.
     * @param node xml node.
     */
    public void parse(Node node);

    /**
     * resets the object.
     */
    public void reset();

    /**
     * sets the model.
     * @param model the model.
     */
    public void setModel(IModelMpeFw model);
}


